log4cplus::NTEventLogAppender Class Reference

Appends log events to NT EventLog. More...

`#include <nteventlogappender.h>`

Inheritance diagram for log4cplus::NTEventLogAppender:
[legend]
Collaboration diagram for log4cplus::NTEventLogAppender:
[legend]

## Public Member Functions

| NTEventLogAppender (const log4cplus::tstring &server, const log4cplus::tstring &log, const log4cplus::tstring &source)
| NTEventLogAppender (const log4cplus::helpers::Properties &properties)
virtual | ~NTEventLogAppender ()
virtual void | close ()
| Release any resources allocated within the appender such as file handles, network connections, etc.
Public Member Functions inherited from log4cplus::Appender
| Appender ()
| Appender (const log4cplus::helpers::Properties &properties)
virtual | ~Appender ()
void | destructorImpl ()
| This function is for derived appenders to call from their destructors.
bool | isClosed () const
| Check if this appender is in closed state.
void | syncDoAppend (const log4cplus::spi::InternalLoggingEvent &event)
| This method performs threshold checks and invokes filters before delegating actual logging to the subclasses specific `append` method.
void | asyncDoAppend (const log4cplus::spi::InternalLoggingEvent &event)
| This method performs book keeping related to asynchronous logging and executes syncDoAppend() to do the actual logging.
void | doAppend (const log4cplus::spi::InternalLoggingEvent &event)
| This function checks async flag.
virtual log4cplus::tstring | getName ()
| Get the name of this appender.
virtual void | setName (const log4cplus::tstring &name)
| Set the name of this appender.
virtual void | setErrorHandler (std::unique_ptr< ErrorHandler > eh)
| Set the `ErrorHandler` for this Appender.
virtual ErrorHandler * | getErrorHandler ()
| Return the currently set `ErrorHandler` for this Appender.
virtual void | setLayout (std::unique_ptr< Layout > layout)
| Set the layout for this appender.
virtual Layout * | getLayout ()
| Returns the layout of this appender.
void | setFilter (log4cplus::spi::FilterPtr f)
| Set the filter chain on this Appender.
log4cplus::spi::FilterPtr | getFilter () const
| Get the filter chain on this Appender.
void | addFilter (log4cplus::spi::FilterPtr f)
| Add filter at the end of the filters chain.
void | addFilter (std::function< spi::FilterResult(const log4cplus::spi::InternalLoggingEvent &)>)
| Add filter at the end of the filters chain.
LogLevel | getThreshold () const
| Returns this appenders threshold LogLevel.
void | setThreshold (LogLevel th)
| Set the threshold LogLevel.
bool | isAsSevereAsThreshold (LogLevel ll) const
| Check whether the message LogLevel is below the appender's threshold.
void | waitToFinishAsyncLogging ()
| This method waits for all events that are being asynchronously logged to finish.
Public Member Functions inherited from log4cplus::helpers::SharedObject
void | addReference () const LOG4CPLUS_NOEXCEPT
void | removeReference () const

## Protected Member Functions

virtual void | append (const spi::InternalLoggingEvent &event)
| Subclasses of `Appender` should implement this method to perform actual logging.
virtual WORD | getEventType (const spi::InternalLoggingEvent &event)
virtual WORD | getEventCategory (const spi::InternalLoggingEvent &event)
void | init ()
void | addRegistryInfo ()
Protected Member Functions inherited from log4cplus::Appender
tstring & | formatEvent (const log4cplus::spi::InternalLoggingEvent &event) const
Protected Member Functions inherited from log4cplus::helpers::SharedObject
| SharedObject ()
| SharedObject (const SharedObject &)
| SharedObject (SharedObject &&)
virtual | ~SharedObject ()
SharedObject & | operator= (const SharedObject &) LOG4CPLUS_NOEXCEPT
SharedObject & | operator= (SharedObject &&) LOG4CPLUS_NOEXCEPT

## Protected Attributes

log4cplus::tstring | server
log4cplus::tstring | log
log4cplus::tstring | source
HANDLE | hEventLog
SID * | pCurrentUserSID
Protected Attributes inherited from log4cplus::Appender
std::unique_ptr< Layout > | layout
| The layout variable does not need to be set if the appender implementation has its own layout.
log4cplus::tstring | name
| Appenders are named.
LogLevel | threshold
| There is no LogLevel threshold filtering by default.
log4cplus::spi::FilterPtr | filter
| The first filter in the filter chain.
std::unique_ptr< ErrorHandler > | errorHandler
| It is assumed and enforced that errorHandler is never null.
std::unique_ptr< helpers::LockFile > | lockFile
| Optional system wide synchronization lock.
bool | useLockFile
bool | async
| Asynchronous append.
std::atomic< std::size_t > | in_flight
std::mutex | in_flight_mutex
std::condition_variable | in_flight_condition
bool | closed
| Is this appender closed?

## Additional Inherited Members

Public Attributes inherited from log4cplus::helpers::SharedObject
thread::Mutex | access_mutex

## Detailed Description

Appends log events to NT EventLog.

Definition at line 43 of file nteventlogappender.h.

## Constructor & Destructor Documentation

## NTEventLogAppender() [1/2]

log4cplus::NTEventLogAppender::NTEventLogAppender | ( | const log4cplus::tstring & | server,
|  | const log4cplus::tstring & | log,
|  | const log4cplus::tstring & | source )

References log, server, and source.

## NTEventLogAppender() [2/2]

log4cplus::NTEventLogAppender::NTEventLogAppender | ( | const log4cplus::helpers::Properties & | properties | ) |

## ~NTEventLogAppender()

virtual log4cplus::NTEventLogAppender::~NTEventLogAppender | ( |  | ) |

virtual

## Member Function Documentation

## addRegistryInfo()

void log4cplus::NTEventLogAppender::addRegistryInfo | ( |  | ) |

protected

## append()

virtual void log4cplus::NTEventLogAppender::append | ( | const spi::InternalLoggingEvent & | event | ) |

protected virtual

Subclasses of `Appender` should implement this method to perform actual logging.

See also
  doAppend method.

Implements log4cplus::Appender.

## close()

virtual void log4cplus::NTEventLogAppender::close | ( |  | ) |

virtual

Release any resources allocated within the appender such as file handles, network connections, etc.

It is a programming error to append to a closed appender.

Implements log4cplus::Appender.

## getEventCategory()

virtual WORD log4cplus::NTEventLogAppender::getEventCategory | ( | const spi::InternalLoggingEvent & | event | ) |

protected virtual

## getEventType()

virtual WORD log4cplus::NTEventLogAppender::getEventType | ( | const spi::InternalLoggingEvent & | event | ) |

protected virtual

## init()

void log4cplus::NTEventLogAppender::init | ( |  | ) |

protected

## Member Data Documentation

## hEventLog

HANDLE log4cplus::NTEventLogAppender::hEventLog

protected

Definition at line 72 of file nteventlogappender.h.

## log

log4cplus::tstring log4cplus::NTEventLogAppender::log

protected

Definition at line 70 of file nteventlogappender.h.

Referenced by NTEventLogAppender().

## pCurrentUserSID

SID* log4cplus::NTEventLogAppender::pCurrentUserSID

protected

Definition at line 73 of file nteventlogappender.h.

## server

log4cplus::tstring log4cplus::NTEventLogAppender::server

protected

Definition at line 69 of file nteventlogappender.h.

Referenced by NTEventLogAppender().

## source

log4cplus::tstring log4cplus::NTEventLogAppender::source

protected

Definition at line 71 of file nteventlogappender.h.

Referenced by NTEventLogAppender().

The documentation for this class was generated from the following file:

- nteventlogappender.h